:- use_module(library(clpfd)).
:- ensure_loaded('fdpred_semantics/fdcheck').

% A fenti sor felttelezi, hogy ez a file a trgy honlapjrl letlttt
% ndp13-gyak.tgz llomnybl lett kicsomagolva. Ha ez a felttelezs nem
% igaz, akkor az fdpred_semantics csomagot le kell tlteni innen:

% http://cs.bme.hu/~szeredi/ndp/fdpred_semantics_v5.tgz

% s ki kell csomagolni a jelen file knyvtrba.

:- fd_check_options([verbose]).

% 1.

% % '2x+y=z'(X,Y,Z): 2*X + Y = Z

% A korlt legyen reifiklhat! Elegend intervallum-konzisztencit
% ill. intervallum-levezethetsget biztostani.

:- fd_pred_semantics('2x+y=z'(X,Y,Z), 2*X+Y =:= Z).
:- fd_test_range(1, 5).

'2x+y=z'(X,Y,Z) +:
        X in (min(Z) - max(Y)) /> 2 .. (max(Z) - min(Y)) /< 2,
	Y in min(Z) - max(X)*2      ..  max(Z) - min(X)*2,
        Z in min(X)*2 + min(Y)      ..  max(X)*2 + max(Y).

'2x+y=z'(X,Y,Z) -:
        X in ({(Z-Y) mod 2} /\ {1}) ? (inf..sup) \/ (\{(Z-Y)/>2}),
	Y in \{Z-X*2},
	Z in \{2*X+Y}.

'2x+y=z'(X,Y,Z) +?
        Z in {2*X+Y}.

'2x+y=z'(X,Y,Z) -?	
	X in ({(Z-Y) mod 2} /\ {1}) ? (inf..sup) \/ (\{(Z-Y)/>2}).

% 2.



% % 'x+2=y'(X,Y): X + 2 = Y

% A korlt legyen tartomny-konzisztens!
% Nem (felttlenl) kell megrnod a reifiklst biztost FD-klzokat.

:- fd_pred_semantics('x+2=y'(X,Y), X+2 =:= Y).
:- fd_test_range(1, 5).

'x+2=y'(X,Y) +:
	Y in dom(X)+2,
	X in (dom(Y)-2).


/* Intervallum-konzisztens vltozat:

'x+2=y'(X,Y):+
	Y in (min(X)+2)..(max(X)+2),
	X in (min(Y)-2)..(max(Y)-2).

*/

% 3.

% kiskulonbseg(A,B,C): C nem-negatv egsz s A s B klnbsgnek abszolt
% rtke kisebb, mint C.

% Elegend intervallum-konzisztencit biztostani.
% Nem (felttlenl) kell megrnod a reifiklst biztost FD-klzokat.

:- fd_pred_semantics(kiskulonbseg(A,B,C), (C >= 0, abs(A-B) =< C)).
:- fd_test_range(-1, 2).

kiskulonbseg(A,B,C) +:
	A in min(B) - max(C) .. max(B) + max(C),
	B in min(A) - max(C) .. max(A) + max(C),
	C in (0..sup) /\ (min(A) - max(B) .. sup) /\ (min(B) - max(A) .. sup).


