:- use_module(library(clpfd)).
:- ensure_loaded('fdpred_semantics/fdcheck').

% A fenti sor felttelezi, hogy ez a file a trgy honlapjrl letlttt
% ndp13-gyak.tgz llomnybl lett kicsomagolva. Ha ez a felttelezs nem
% igaz, akkor az fdpred_semantics csomagot le kell tlteni innen:

% http://cs.bme.hu/~szeredi/ndp/fdpred_semantics_v5.tgz

% s ki kell csomagolni a jelen file knyvtrba.

:- fd_check_options([verbose]).

% % egyikpoz(A, B): Az A, B szmok kzl pontosan egy pozitv (> 0)

% Legyen az FD-prediktum reifiklhat (rd meg mind a ngy klzt)!

% Trekedj arra, hogy az FD-prediktum tartomny-szktst ill.
% tartomny-levezethetsget biztostson!

:- fd_pred_semantics(egyikpoz(A, B), (A > 0 -> B =< 0 ; B > 0)).

egyikpoz(A,B) +:
	A in (dom(B) /\ (inf..0)) ? (1..sup) \/ (dom(B) /\ (1..sup)) ? (inf..0),
	B in (dom(A) /\ (inf..0)) ? (1..sup) \/ (dom(A) /\ (1..sup)) ? (inf..0).
egyikpoz(A,B) -:
	A in (dom(B) /\ (inf..0)) ? (inf..0) \/ (dom(B) /\ (1..sup)) ? (1..sup),
	B in (dom(A) /\ (inf..0)) ? (inf..0) \/ (dom(A) /\ (1..sup)) ? (1..sup).
egyikpoz(A,B) +?
	A in \((dom(B)/\(inf..0)) ? (inf..0) \/ (dom(B)/\(1..sup)) ? (1..sup)).
egyikpoz(A,B) -?
	A in \((dom(B)/\(inf..0)) ? (1..sup) \/ (dom(B)/\(1..sup)) ? (inf..0)).


% 2. 

% % egyike(X, A, B): Az A s B szmok (legalbb) egyike azonos X-szel.

% Legyen az FD-prediktum reifiklhat (rd meg mind a ngy klzt)!

% Els megoldsknt nem kell tartomny-szktst ill.
% tartomny-levezethetsget biztostanod, de trekedj arra, hogy az albbi
% pldkban a megadott szktseket biztostsad.

% Szorgalmi feladatknt rj egy olyan  egyike_dc nev vltozatot, amely a
% (*)-gal jellt esetekben is szkt.

% | ?- egyike(X, A, B), A in {1,3,8}, X in {2,9}. ==> X in(1..3)\/(8..9)
% | ?- egyike(X, A, B), X in {1,3,8}, B in {2,3}. ==> A in inf..sup
% | ?- egyike(X, A, B), X in {1,3,8}, B in {2,9}. ==> A in{1}\/{3}\/{8}
% | ?- egyike(X, A, B) #<=> 0, A = 1.             ==> X in inf..sup,        (*)
% | ?- egyike(X, A, B) #<=> 0, A = 1, B = 2.      ==> X in(inf..0)\/(3..sup)
% | ?- egyike(X, A, B) #<=> T, A = 1, X = 1.      ==> T in 0..1             (*)
% | ?- egyike(X, A, B) #<=> T, A = 1, X = 1, B=2. ==> T = 1
% | ?- egyike(X, A, B) #<=> T, X in 1 .. 10, 
%      A in 20..30, B in 40..50.                  ==> T = 0

% | ?- egyike_dc(X, A, B) #<=> 0, A = 1.          ==> X in(inf..0)\/(2..sup)
% | ?- egyike_dc(X, A, B) #<=> T, A = 1, X = 1    ==> T = 1


:- fd_pred_semantics('egyike'(X,A,B), (X=A;X=B)).

egyike(X, A, B) +:
	X in dom(A) \/ dom(B),
	A in (dom(X) /\ dom(B)) ? (inf..sup) \/ dom(X),
	B in (dom(X) /\ dom(A)) ? (inf..sup) \/ dom(X).
egyike(X, A, B) -:
	X in (\{A}) /\ (\{B}),
	A in ((X .. B-1)\/(B .. X-1)) ? (\{X}),
	B in ((X .. A-1)\/(A .. X-1)) ? (\{X}).
egyike(X, A, B) +?
	X in {A,B}.
egyike(X, A, B) -?
	X in \ ( dom(A) \/ dom(B) ).

:- fd_pred_semantics('egyike_dc'(X,A,B), (X=A;X=B)).

egyike_dc(X, A, B) +:
	X in dom(A) \/ dom(B),
	A in (dom(X) /\ dom(B)) ? (inf..sup) \/ dom(X),
	B in (dom(X) /\ dom(A)) ? (inf..sup) \/ dom(X).
egyike_dc(X, A, B) -:
	X in (((inf..(max(A)-1)))\/((min(A)+1)..sup))/\
	     (((inf..(max(B)-1)))\/((min(B)+1)..sup)),
	A in (((min(X)..(max(B)-1)))\/((min(B)..(max(X)-1))))? (((inf..(max(X)-1)))\/((min(X)+1)..sup)),
	B in (((min(X)..(max(A)-1)))\/((min(A)..(max(X)-1))))? (((inf..(max(X)-1)))\/((min(X)+1)..sup)).
egyike_dc(X, A, B) +?
	X in \ ((((inf..(max(A)-1)))\/((min(A)+1)..sup))/\
	     (((inf..(max(B)-1)))\/((min(B)+1)..sup))).
egyike_dc(X, A, B) -?
	X in \ ( dom(A) \/ dom(B) ).
