:- use_module(library(chr)).
:- use_module(library(lists)).


% 1.  Rendezs felcserlssel.
%     Egy szmtmbt brzoljunk a(Index,Ertek) prok alakjban
%     brzolunk. rj CHR szablyt, mely megvalstja a tmb rendezst.

%     (...)

%     | ?- a(1, 5), a(2, 3), a(3, 4), a(4, 2).
%     a(1,2),
%     a(2,3),
%     a(3,4),
%     a(4,5) ? ;
%     no
%     | ?- 

:- chr_constraint a/2.
a(I,V), a(J,W) <=> I>J, V<W | a(I,W),a(J,V).

%     Hogyan kell mdostani a megoldst ahhoz, hogy a szmtmbt cskken
%     sorrendbe rendezzk?

:- chr_constraint b/2.
b(I,W), b(J,V) <=> I>J, V<W | b(I,V),b(J,W).


% 2.  Keresztrejtvny: Helyezznk el hat ngybets szt egy olyan
%     keresztrejtvnyben, melynek 4 sora van s a maradk kt sz a kzps kt
%     oszlopba kerl. 

%     | ?- szo(m,a,r,i), szo(c,s,a,k), szo(s,a,j,t), 
%          szo(o,t,t,o), szo(a,j,a,x), szo(a,r,a,t).
%     megoldas([[c,s,a,k],
%               [m,a,r,i],
%               [a,j,a,x],
%               [o,t,t,o]]) ? ;
%     no
%     | ?-

:- chr_constraint szo/4, megoldas/1.
szo(A1,B1,C1,D1), szo(A2,B2,C2,D2), szo(A3,B3,C3,D3),szo(A4,B4,C4,D4),
szo(B1,B2,B3,B4), szo(C1,C2,C3,C4) <=> megoldas([[A1,B1,C1,D1],
                                                  [A2,B2,C2,D2],
                                                  [A3,B3,C3,D3],
                                                  [A4,B4,C4,D4]]).
teszt_szo:-
        szo(m,a,r,i),
        szo(c,s,a,k),
        szo(s,a,j,t),
        szo(o,t,t,o),
        szo(a,j,a,x),
        szo(a,r,a,t).


%     "Csomagoljuk" be a fenti feladat megoldshoz szksges korltokat egy
%     elrendez/2 Prolog eljrsba.

%     | ?- elrendez([[m,a,r,i], [c,s,a,k], [s,a,j,t], 
%                    [o,t,t,o], [a,j,a,x], [a,r,a,t]], Mx).
%     Mx = [[c,s,a,k],
%           [m,a,r,i],
%           [a,j,a,x],
%           [o,t,t,o]]) ? ;
%     no
%     | ?- 

elrendez(Szavak, Mx) :-
	(   foreach(Szo, Szavak)
	do  szo(Szo)
	),
	eredmeny(Mx).


:- chr_constraint szo/1, eredmeny/1.

szo(L1), szo(L2), szo(L3), szo(L4), szo(L5), szo(L6), eredmeny(Mx) <=>
                  Mx0 = [L1,L2,L3,L4],
		  transpose(Mx0, [_,L5,L6|_])|
		  Mx = Mx0.


teszt_elrendez(Mx) :-
	elrendez( [
	   [m,a,r,i],
	   [c,s,a,k],
	   [s,a,j,t],
	   [o,t,t,o],
	   [a,j,a,x],
	   [a,r,a,t]], Mx).
